import greenfoot.*;

public class Barrel extends Actor
{
    public Barrel()
    {
        GreenfootImage image = getImage();
        image.scale(image.getWidth()*3/4, image.getHeight()*3/4);
    }
    
    public boolean canMove(int dx, int dy)
    {
        HexWorld hw = (HexWorld)getWorld();
        int curX = getX(), curY = getY();
        int wx = curX+dx, wy = curY+dy;
        if (!hw.isHexLocation(hw.getHexX(wx, wy), hw.getHexY(wx, wy))) return false;
        if (hw.getBackground().getColorAt(wx, wy).equals(hw.getInactiveFillColor())) return false;
        setLocation(wx, wy);
        Barrel barrel = (Barrel)getOneObjectAtOffset(0, 0, Barrel.class);
        if (barrel == null) return true;
        setLocation(curX, curY);
        return false;        
    }
}