import greenfoot.*;

public class Kara extends Actor
{
    private boolean downedKey;
    private boolean finished;
    private int moves;
    GreenfootImage karaImg = new GreenfootImage("kara.png");
    private int imgSizeFactor = 50;
    private int factorDir = 1;
    
    public Kara()
    {
        scaleImage();
    }
    
    private void scaleImage()
    {
        GreenfootImage image = new GreenfootImage(karaImg);
        image.scale(image.getWidth()*imgSizeFactor/100, image.getHeight()*imgSizeFactor/100);
        setImage(image);
    }

    public void act()
    {
        if (finished)
        {
            imgSizeFactor += factorDir;
            if (imgSizeFactor == 60 || imgSizeFactor == 50)
            {
                factorDir = -factorDir;
                scaleImage();
            }
            return;
        }
        if (Greenfoot.mouseClicked(null))
        {
            MouseInfo m = Greenfoot.getMouseInfo();
            int angle = ((int)(Math.atan2(m.getY()-getY(), m.getX()-getX())*180.0/Math.PI)+360)%360;
            int dx = 30, dy = -20;
            if (angle < 300) { dx = 0; dy = -40; }
            if (angle < 240) { dx = -30; dy = -20; }
            if (angle < 180) { dx = -30; dy = 20; }
            if (angle < 120) { dx = 0; dy = 40; }
            if (angle < 60) { dx = 30; dy = 20; }
            move(dx, dy);
            return;
        }            
        int dx = 0, dy = 0;
        if (downedKey && !Greenfoot.isKeyDown("up") && !Greenfoot.isKeyDown("down")) downedKey = false;
        if (downedKey) return;
        if (Greenfoot.isKeyDown("up"))
        {
            if (Greenfoot.isKeyDown("right") && !Greenfoot.isKeyDown("left")) { dx = 30; dy = -20; }
            if (Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("right")) { dx = -30; dy = -20; }
            if (!Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("right")) { dx = 0; dy = -40; }
            downedKey = true;
        }
        if (Greenfoot.isKeyDown("down"))
        {
            if (Greenfoot.isKeyDown("right") && !Greenfoot.isKeyDown("left")) { dx = 30; dy = 20; }
            if (Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("right")) { dx = -30; dy = 20; }
            if (!Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("right")) { dx = 0; dy = 40; }
            downedKey = true;
        }
        if (dx != 0 || dy != 0) move(dx, dy);
    }
    
    private boolean move(int dx, int dy)
    {
        HexWorld hw = (HexWorld)getWorld();
        int curX = getX(), curY = getY();
        int wx = curX+dx, wy = curY+dy;
        if (!hw.isHexLocation(hw.getHexX(wx, wy), hw.getHexY(wx, wy))) return false;
        if (hw.getBackground().getColorAt(wx, wy).equals(hw.getInactiveFillColor())) return false;
        setLocation(wx, wy);
        Barrel barrel = (Barrel)getOneObjectAtOffset(0, 0, Barrel.class);
        setRotation(dx == 0 ? 90*40/dy : dx > 0 ? 30*20/dy : 180-30*20/dy);
        if (barrel == null || barrel.canMove(dx, dy))
        {
            moves++;
            ((Hexy)getWorld()).updateMoveDisp(moves);
            return true;
        }
        setLocation(curX, curY);
        return false;
    }
    
    public int getMoves()
    {
        return moves;
    }
    
    public void setFinished()
    {
        finished = true;
    }
}